"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const cosmiconfig_1 = require("cosmiconfig");
const defaultConfig_1 = __importDefault(require("../defaultConfig"));
const pkg = require('../../package.json');
function mergeConfigs(defConf, userConf) {
    return {
        rules: Object.assign(Object.assign({}, defConf.rules), userConf.rules),
        ignore: Object.assign({}, userConf.ignore),
    };
}
function getConfig(configPath) {
    var _a, _b;
    const cosmiconfig = cosmiconfig_1.cosmiconfigSync(pkg.name);
    if (configPath) {
        const loadedConfig = (_a = cosmiconfig.load(path_1.default.resolve(configPath))) === null || _a === void 0 ? void 0 : _a.config;
        if (loadedConfig) {
            return {
                config: mergeConfigs(defaultConfig_1.default, loadedConfig),
                error: null,
            };
        }
        else {
            return {
                config: defaultConfig_1.default,
                error: 'Swaggerlint config with a provided path does not exits.',
            };
        }
    }
    else {
        const lookedupConfig = (_b = cosmiconfig.search()) === null || _b === void 0 ? void 0 : _b.config;
        if (lookedupConfig) {
            return {
                config: mergeConfigs(defaultConfig_1.default, lookedupConfig),
                error: null,
            };
        }
        else {
            return {
                config: defaultConfig_1.default,
                error: null,
            };
        }
    }
}
exports.getConfig = getConfig;
