"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const isDev = process.env.NODE_ENV === 'development';
exports.log = isDev ? (x) => console.log(`--> ${x}`) : () => null;
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isRef(arg) {
    return typeof arg.$ref === 'string';
}
exports.isRef = isRef;
function isSchemaObjectAllOfObject(
// eslint-disable-next-line @typescript-eslint/no-explicit-any
arg) {
    return Array.isArray(arg.allOf);
}
exports.isSchemaObjectAllOfObject = isSchemaObjectAllOfObject;
const visitorSet = new Set([
    'SwaggerObject',
    'InfoObject',
    'PathsObject',
    'DefinitionsObject',
    'ParametersDefinitionsObject',
    'ResponsesDefinitionsObject',
    'SecurityDefinitionsObject',
    'SecuritySchemeObject',
    'ScopesObject',
    'SecurityRequirementObject',
    'TagObject',
    'ExternalDocumentationObject',
    'ContactObject',
    'LicenseObject',
    'PathItemObject',
    'OperationObject',
    'ParameterObject',
    'ResponsesObject',
    'ResponseObject',
    'SchemaObject',
    'XMLObject',
    'HeadersObject',
    'HeaderObject',
    'ItemsObject',
    'ExampleObject',
]);
function isValidVisitorName(name) {
    return visitorSet.has(name);
}
exports.isValidVisitorName = isValidVisitorName;
exports.validCases = {
    camel: new Set(['camel', 'lower']),
    snake: new Set(['snake', 'lower']),
    pascal: new Set(['pascal']),
    constant: new Set(['constant']),
};
function isValidCaseName(name) {
    return name in exports.validCases;
}
exports.isValidCaseName = isValidCaseName;
