import { SwaggerObject, InfoObject, PathsObject, DefinitionsObject, ParametersDefinitionsObject, ResponsesDefinitionsObject, SecurityDefinitionsObject, SecuritySchemeObject, ScopesObject, SecurityRequirementObject, TagObject, ExternalDocumentationObject, ContactObject, LicenseObject, PathItemObject, OperationObject, ParameterObject, ResponsesObject, ResponseObject, SchemaObject, XMLObject, HeadersObject, HeaderObject, ItemsObject, ExampleObject, LintError, ConfigIgnore } from './types';
declare type OneOrNone<T> = [T] | [];
declare type NodeWithLocation<T> = {
    node: T;
    location: string[];
};
declare type Visitors = {
    SwaggerObject: [NodeWithLocation<SwaggerObject>];
    InfoObject: [NodeWithLocation<InfoObject>];
    PathsObject: [NodeWithLocation<PathsObject>];
    DefinitionsObject: OneOrNone<NodeWithLocation<DefinitionsObject>>;
    ParametersDefinitionsObject: OneOrNone<NodeWithLocation<ParametersDefinitionsObject>>;
    ResponsesDefinitionsObject: OneOrNone<NodeWithLocation<ResponsesDefinitionsObject>>;
    SecurityDefinitionsObject: OneOrNone<NodeWithLocation<SecurityDefinitionsObject>>;
    SecuritySchemeObject: NodeWithLocation<SecuritySchemeObject>[];
    ScopesObject: NodeWithLocation<ScopesObject>[];
    SecurityRequirementObject: NodeWithLocation<SecurityRequirementObject>[];
    TagObject: NodeWithLocation<TagObject>[];
    ExternalDocumentationObject: NodeWithLocation<ExternalDocumentationObject>[];
    ContactObject: OneOrNone<NodeWithLocation<ContactObject>>;
    LicenseObject: OneOrNone<NodeWithLocation<LicenseObject>>;
    PathItemObject: NodeWithLocation<PathItemObject>[];
    OperationObject: NodeWithLocation<OperationObject>[];
    ParameterObject: NodeWithLocation<ParameterObject>[];
    ResponsesObject: NodeWithLocation<ResponsesObject>[];
    ResponseObject: NodeWithLocation<ResponseObject>[];
    SchemaObject: NodeWithLocation<SchemaObject>[];
    XMLObject: NodeWithLocation<XMLObject>[];
    HeadersObject: NodeWithLocation<HeadersObject>[];
    HeaderObject: NodeWithLocation<HeaderObject>[];
    ItemsObject: NodeWithLocation<ItemsObject>[];
    ExampleObject: NodeWithLocation<ExampleObject>[];
};
declare type WalkerResult = {
    visitors: Visitors;
} | {
    errors: LintError[];
};
declare function walker(swagger: SwaggerObject, ignore?: ConfigIgnore): WalkerResult;
export default walker;
